' Script to display the languages available in WikiPedia.
' Depending on your locale settings, not all local
' language names may be displayed correctly.
' Written by Rob van der Woude
' http://www.robvanderwoude.com
Option Explicit

Dim arrLang( )
Dim i
Dim objHTTP, objMatch, objMatches, objRE
Dim strHTML, strMsg, strURL

' Read and save the entire URL including HTML tags in a variable named strHTML
Set objHTTP = CreateObject( "WinHttp.WinHttpRequest.5.1" )
strURL = "http://meta.wikimedia.org/wiki/List_of_Wikipedias"
objHTTP.Open "GET", strURL
objHTTP.Send
If objHTTP.Status = 200 Then
	strHTML = objHTTP.ResponseText
End If
Set objHTTP = Nothing

' Parse the languages tables and save the results in a 2-dimensional array named arrLang;
' arrLang(0) is the language code
' arrLang(1) is the local language name
' arrLang(2) is the English language name
Set objRE = New RegExp
objRE.Global = True
objRE.IgnoreCase = True
objRE.Pattern = "<tr>[^<]*<td>[0-9,]+</td>[^<]*<td><a [^>]+>([^<]+)</a></td>[^<]*<td[^>]*><a [^>]+>([^<]+)</a></td>[^<]*<td><a [^>]+>([^<]+)</a></td>"
Set objMatches = objRE.Execute( strHTML )
For Each objMatch In objMatches
	If objMatch.Submatches.Count > 2 Then
		ReDim Preserve arrLang( 2, i )
		arrLang( 0, i ) = objMatch.Submatches.Item(2)
		arrLang( 1, i ) = objMatch.Submatches.Item(1)
		arrLang( 2, i ) = objMatch.Submatches.Item(0)
		i = i + 1
	End If
Next
Set objRE = Nothing

' Now show some results
WScript.Echo "Language codes for WikiPedia" & vbCrLf

strMsg = vbCrLf _
       & "Sorted by language codes" & vbCrLf _
       & "========================" & vbCrLf
Sort2Dim arrLang, 0
For i = 0 To UBound( arrLang, 2 )
	strMsg = strMsg & arrLang( 0, i ) & vbTab & arrLang( 1, i ) & vbtab & "(" & arrLang( 2, i ) & ")" & vbCrLf
Next
WScript.Echo strMsg


strMsg = vbCrLf _
       & "Sorted by local language names" & vbCrLf _
       & "==============================" & vbCrLf
Sort2Dim arrLang, 1
For i = 0 To UBound( arrLang, 2 )
	strMsg = strMsg & arrLang( 0, i ) & vbTab & arrLang( 1, i ) & vbtab & "(" & arrLang( 2, i ) & ")" & vbCrLf
Next
WScript.Echo strMsg


strMsg = vbCrLf _
       & "Sorted by English language names" & vbCrLf _
       & "================================" & vbCrLf
Sort2Dim arrLang, 2
For i = 0 To UBound( arrLang, 2 )
	strMsg = strMsg & arrLang( 0, i ) & vbTab & arrLang( 2, i ) & vbTab & "(" & arrLang( 1, i ) & ")" & vbCrLf
Next
WScript.Echo strMsg


' Sort a 2-dimensional array by its specified index in the 1st dimension
Sub Sort2Dim( ByRef myArray, myIndex )
    Dim i, j, arrHolder( 2 )
    For i = ( UBound( myArray, 2 ) - 1 ) to 0 Step -1
        For j= 0 to i
            If UCase( myArray( myIndex, j ) ) > UCase( myArray( myIndex, j + 1 ) ) Then
                arrHolder( 0 )      = myArray( 0, j + 1 )
                arrHolder( 1 )      = myArray( 1, j + 1 )
                arrHolder( 2 )      = myArray( 2, j + 1 )
                myArray( 0, j + 1 ) = myArray( 0, j )
                myArray( 1, j + 1 ) = myArray( 1, j )
                myArray( 2, j + 1 ) = myArray( 2, j )
                myArray( 0, j )     = arrHolder( 0 )
                myArray( 1, j )     = arrHolder( 1 )
                myArray( 2, j )     = arrHolder( 2 )
            End If
        Next
    Next 
End Sub